// // countryCitySelector.js
//
// (function ($) {
//     $.fn.countryCitySelector = function (options) {
//         // Options par défaut
//         var defaults = {
//             countryId: null,
//             cityId: null,
//             initialCountry: null,
//             initialCity: null,
//             manualCountrySelectId: false,
//         };
//
//         var settings = $.extend({}, defaults, options);
//
//         var CountryJsonURL = window.location.protocol + '//' + window.location.hostname;
//         CountryJsonURL = CountryJsonURL + '/admin/assets/js/countrystate/countriesstates.json';
//
//         $.getJSON(CountryJsonURL, function (data) {
//             var countries = data;
//
//             // Fonction pour remplir le select country manuel
//             function populateManualCountrySelect() {
//                 var manualCountrySelect = $(settings.countryId);
//                 // $.each(countries, function (index, country) {
//                 //     manualCountrySelect.append('<option value="' + country.name + '">' + country.name + '</option>');
//                 // });
//
//                 // Définir la valeur du pays initial si fournie
//                 if (settings.initialCountry) {
//                     manualCountrySelect.val(settings.initialCountry);
//                   setTimeout(function () {
//                       manualCountrySelect.trigger('change'); // Déclencher l'événement de changement pour mettre à jour le select city
//                   },2000)
//
//                 }
//             }
//
//             // Vérifier si l'ID du select country manuel est fourni
//             if (settings.manualCountrySelectId) {
//                 populateManualCountrySelect();
//             } else {
//                 // Si aucun ID de select country manuel n'est fourni, créer dynamiquement le select country
//                 var countrySelect = $(settings.countryId);
//                 $.each(countries, function (index, country) {
//                     countrySelect.append('<option value="' + country.name + '">' + country.name + '</option>');
//                 });
//
//                 // Définir la valeur du pays initial si fournie
//                 if (settings.initialCountry) {
//                     countrySelect.val(settings.initialCountry);
//                     countrySelect.trigger('change'); // Déclencher l'événement de changement pour mettre à jour le select city
//                 }
//             }
//
//             // Gestionnaire d'événement pour le select country
//             $(document).on('change', settings.countryId, function () {
//
//                 var selectedCountry = $(this).val();
//                 if (selectedCountry == "Belgique"){
//                     selectedCountry = "Belgium";
//                 }
//                 var selectedCountryObj = countries.find(function (country) {
//                     return country.name === selectedCountry;
//                 });
//
//                 // Vider le select city
//                 var citySelect = $(settings.cityId);
//                 citySelect.empty();
//
//                 // Remplir le select city en fonction du pays sélectionné
//                 if (selectedCountryObj) {
//                     $.each(selectedCountryObj.states, function (index, city) {
//                         citySelect.append('<option value="' + city.name + '">' + city.name + '</option>');
//                     });
//                 }
//             });
//
//             // Définir la valeur de la ville initiale si fournie
//             if (settings.initialCity) {
//                 var citySelect = $(settings.cityId);
//                 citySelect.val(settings.initialCity);
//             }
//         });
//     };
// })(jQuery);
// countryCitySelector.js

(function ($) {
    var countriesPromise = null;

    $.fn.countryCitySelector = function (options) {
        // Options par défaut
        var defaults = {
            countryId: null,
            cityId: null,
            initialCountry: null,
            initialCity: null,
            manualCountrySelectId: false,
            manualCountryExiste: false
        };

        var settings = $.extend({}, defaults, options);

        if (!countriesPromise) {
            var CountryJsonURL = window.location.protocol + '//' + window.location.hostname;
            CountryJsonURL = CountryJsonURL + '/admin/assets/js/countrystate/countriesstates.json';

            countriesPromise = $.getJSON(CountryJsonURL);
        }

        countriesPromise.then(function (data) {
            var countries = data;

            // Fonction pour remplir le select country manuel
            function populateManualCountrySelect() {
                var manualCountrySelect = $(settings.countryId);
                if (settings.manualCountryExiste){
                    $.each(countries, function (index, country) {
                        manualCountrySelect.append('<option value="' + country.name + '">' + country.name + '</option>');
                    });
                }


                // Définir la valeur du pays initial si fournie
                if (settings.initialCountry) {
                    manualCountrySelect.val(settings.initialCountry);
                    setTimeout(function () {
                      manualCountrySelect.trigger('change'); // Déclencher l'événement de changement pour mettre à jour le select city
                        console.log('trigger')
                  },2000)
                }
            }

            // Vérifier si l'ID du select country manuel est fourni
            if (settings.manualCountrySelectId) {
                populateManualCountrySelect();
            } else {
                // Si aucun ID de select country manuel n'est fourni, créer dynamiquement le select country
                var countrySelect = $(settings.countryId);
                $.each(countries, function (index, country) {
                    countrySelect.append('<option value="' + country.name + '">' + country.name + '</option>');
                });

                // Définir la valeur du pays initial si fournie
                if (settings.initialCountry) {
                    countrySelect.val(settings.initialCountry);
                    countrySelect.trigger('change'); // Déclencher l'événement de changement pour mettre à jour le select city
                }
            }

            // Gestionnaire d'événement pour le select country
            $(document).on('change', settings.countryId, function () {
                var selectedCountry = $(this).val();
                if (selectedCountry == "Belgique"){
                    selectedCountry = "Belgium";
                }
                var selectedCountryObj = countries.find(function (country) {
                    return country.name === selectedCountry;
                });

                // Vider le select city
                var citySelect = $(settings.cityId);
                citySelect.empty();

                // Remplir le select city en fonction du pays sélectionné
                if (selectedCountryObj) {
                    $.each(selectedCountryObj.states, function (index, city) {
                        citySelect.append('<option value="' + city.name + '">' + city.name + '</option>');
                    });
                }
            });

            // Définir la valeur de la ville initiale si fournie
            if (settings.initialCity) {
                var citySelect = $(settings.cityId);
                citySelect.val(settings.initialCity);
            }
        });
    };
})(jQuery);
